VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DirRecurse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

' Recursive function to load a TreeView Control with a directory structure
'   adapted for project WbrFavs
' Requires Project/References to "Microsoft Scripting Runtime" (scrrun.dll)
'==========================================================================
Option Explicit
' Module-level variables
Private mNodes As MSComctlLib.Nodes

Public Function RecurseDirTV( _
                    TView As MSComctlLib.TreeView, _
                    PathName As String) As Long
                            
    Dim RootNode As MSComctlLib.Node

    Set mNodes = TView.Nodes    ' Save as module-level variable
    mNodes.Clear                ' Start with empty TreeView
    Set RootNode = mNodes.Add(, , "Root", PathName)
    Call RecursePathTV(RootNode)     ' Initiate recursion
    AddTreePics
    With RootNode
        .Image = "ClosedFolder"
        .ExpandedImage = "OpenFolder"
        .Expanded = True
    End With
    RecurseDirTV = mNodes.Count
  
End Function

Private Sub RecursePathTV(Parent As MSComctlLib.Node)   ' RECURSIVE

    On Error GoTo RecursePathTV_Error
    
    Dim fsoFolder As Scripting.Folder
    Dim fsoSubFolder As Scripting.Folder
    Dim fsoFile As Scripting.File
    Dim NewNode As MSComctlLib.Node
    Dim posIX As Long
    Dim strURLLine As String
    Dim strText As String
    Dim strTag As String
    
    With New Scripting.FileSystemObject
        Set fsoFolder = .GetFolder(FolderPath:=Parent.FullPath)
    End With
    
    For Each fsoSubFolder In fsoFolder.SubFolders
        Set NewNode = mNodes.Add(Parent.Index, tvwChild, , fsoSubFolder.Name)
        Call RecursePathTV(NewNode) ' Recursive call; traverse sub-directory
    Next fsoSubFolder
    
    For Each fsoFile In fsoFolder.Files
        posIX = InStr(1, fsoFile.Name, ".url", vbTextCompare)
        If posIX Then
            strText = Left$(fsoFile.Name, posIX - 1)
            With fsoFile.OpenAsTextStream
                .ReadLine  ' [InternetShortcut]
                strURLLine = .ReadLine  ' URL=
                .Close
            End With
            If InStr(4, strURLLine, "=", vbTextCompare) Then
                strTag = Mid$(strURLLine, 5)
            Else
                strTag = vbNullString
            End If
            With mNodes.Add(Parent.Index, tvwChild)
                .Text = strText ' Title
                .Tag = strTag   ' URL
            End With
        End If
    Next fsoFile
   
RecursePathTV_Exit:
    Exit Sub
    
RecursePathTV_Error:
    MsgBox Err.Number & ": " & Err.Description, vbExclamation, "DirRecurse.RecursePathTV"
    Resume RecursePathTV_Exit
    
End Sub

Private Sub AddTreePics()
'
' If programming logic permits, adding images all at once seems to be
' significantly faster than doing it as each node is added.
'
    On Error Resume Next
    
    Dim N As MSComctlLib.Node
    
    For Each N In mNodes
        With N
            If .Children Then
                .Image = "ClosedFolder"
                .ExpandedImage = "OpenFolder"
                .Sorted = True
            ElseIf Len(.Tag) Then
                .Image = "LocalDoc"
            Else
                .Image = "BadLink"
            End If
        End With
    Next N
    
End Sub

