Attribute VB_Name = "SHAPI"
Option Explicit

' Supporting module for project WbrFavs
'========================================================================
' WinAPI Declarations
Public Const CSIDL_FAVORITES = &H6
Public Const MAX_PATH = 260
Public Const NOERROR = 0
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" _
       (ByVal hwndOwner As Long, _
        ByVal nFolder As Long, _
        pidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" _
       (ByVal pidl As Long, _
        ByVal pszPath As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" _
       (ByVal hMem As Long)
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" _
       (ByVal lpString As String) As Long

Public Function GetFavFolderPath(HWindow As Long) As String
    
    On Error GoTo GetFavFolderPath_Error
    
    Dim Result As String    ' default function result = ""
    Dim strPath As String
    Dim lpItemIDList As Long
    
    If SHGetSpecialFolderLocation(HWindow, CSIDL_FAVORITES, lpItemIDList) = NOERROR Then
        strPath = Space$(MAX_PATH)
        If SHGetPathFromIDList(lpItemIDList, strPath) Then
            Result = Left$(strPath, lstrlen(strPath))
        End If
    End If
    
GetFavFolderPath_Exit:
    Call CoTaskMemFree(lpItemIDList) ' Non-fatal if lpItemIDList = 0
    GetFavFolderPath = Result
    Exit Function
    
GetFavFolderPath_Error:
    Resume GetFavFolderPath_Exit
    
End Function
